/***************************************************************
 * Name:      LTC5904Main
 * Purpose:   Defines Application Frame
 * Author:    seta43 ()
 * Created:   2020-09-29
 * Copyright: seta43 ()
 * License:
 **************************************************************
 * Copyright: seta43 ()
 * Versión 1	29/09/2020
 * 
 * xsetaseta@gmail.com
 * seta43.duckdns.org
 **************************************************************/

#include "main.h"
#include "define.h"
#include "port.h"

#include "unistd.h"


char CLAVE[] = "LTC5904";

#define MAXINPUT 100
int tiempo0=6,tiempo2=2;
unsigned char portok;
bool inicio=1;

int  ContadorI=0;
char Binput[MAXINPUT];
char Binput2[10];

char VARI[MAXINPUT];

    char CADE1[100]; 
    char CADE2[130];
    int val0,val1,val2;
    


#define DATOSN 128
    
//_________________________

#if YesWindows
    static 	char *myport[]= {"com1","com2","com3","com4","com5","com6","com7","com8","com9","\\\\.\\COM10","\\\\.\\COM11","\\\\.\\COM12"};
#else
	static char *myport[]= {(char *)"/dev/ttyUSB0", (char *)"/dev/ttyUSB1", (char *)"/dev/ttyACM0", (char *)"/dev/ttyACM1", (char *)"/dev/ttyACM2", (char *)"/dev/ttyS0", (char *)"/dev/ttyS1"};
#endif	


DECLARE_APP(MiAplicacion)
// Give wxWidgets the means to create a MiAplicacion object
IMPLEMENT_APP(MiAplicacion)

BEGIN_EVENT_TABLE(LTC5904Frame,wxFrame)
 
END_EVENT_TABLE();



LTC5904Frame::LTC5904Frame(wxWindow* parent,wxWindowID id)
{
  //(*Initialize(LTC5904Frame)
    Create(parent, wxID_ANY, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE, _T("wxID_ANY"));
    SetClientSize(wxSize(320,249));
    SetBackgroundColour(wxColour(239,243,140));
    StaticText1 = new wxStaticText(this, ID_STATICTEXT1, _("LTC5904"), wxPoint(96,16), wxSize(152,40), 0, _T("ID_STATICTEXT1"));
    StaticText1->SetForegroundColour(wxColour(30,59,232));
    wxFont StaticText1Font(20,wxFONTFAMILY_SWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_BOLD,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    StaticText1->SetFont(StaticText1Font);
    TextCtrl1 = new wxTextCtrl(this, ID_TEXTCTRL1, _("Grabador no encontrado"), wxPoint(48,88), wxSize(224,25), wxTE_READONLY, wxDefaultValidator, _T("ID_TEXTCTRL1"));
    TextCtrl1->SetForegroundColour(wxColour(23,74,33));
    wxFont TextCtrl1Font(9,wxFONTFAMILY_TELETYPE,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_NORMAL,false,_T("Courier 10 Pitch"),wxFONTENCODING_DEFAULT);
    TextCtrl1->SetFont(TextCtrl1Font);
    Bconsola = new wxTextCtrl(this, ID_TEXTCTRL2, wxEmptyString, wxPoint(32,120), wxSize(256,25), wxTE_READONLY|wxTE_CENTRE, wxDefaultValidator, _T("ID_TEXTCTRL2"));
    Bconsola->SetForegroundColour(wxColour(113,14,14));
    Bgo = new wxTextCtrl(this, ID_TEXTCTRL3, _("3000"), wxPoint(56,160), wxSize(164,25), wxTE_RIGHT, wxDefaultValidator, _T("ID_TEXTCTRL3"));
    Bgo->SetFocus();
    Bgo->SetForegroundColour(wxColour(36,71,37));
    Bgo->SetBackgroundColour(wxColour(236,233,185));
    wxFont BgoFont(18,wxFONTFAMILY_TELETYPE,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_BOLD,false,_T("Courier"),wxFONTENCODING_DEFAULT);
    Bgo->SetFont(BgoFont);
    Bfrecu = new wxButton(this, ID_BUTTON1, _("GO"), wxPoint(232,152), wxSize(40,40), 0, wxDefaultValidator, _T("ID_BUTTON1"));
    Bexit = new wxButton(this, ID_BUTTON2, _("EXIT"), wxPoint(112,208), wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
    StaticText2 = new wxStaticText(this, ID_STATICTEXT2, _("xsetaseta@gmail.com"), wxPoint(88,56), wxDefaultSize, 0, _T("ID_STATICTEXT2"));
    StaticText2->SetForegroundColour(wxColour(231,28,28));
    
    Timer1.SetOwner(this, ID_TIMER1);
    Timer1.Start(10);

   Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&LTC5904Frame::OnBfrecuClick);
   Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&LTC5904Frame::OnBexitClick);
   Connect(ID_TIMER1,wxEVT_TIMER,(wxObjectEventFunction)&LTC5904Frame::OnTimer1Trigger);
   // Connect(wxID_ANY,wxEVT_CLOSE_WINDOW,(wxObjectEventFunction)&LTC5904Frame::OnClose);

    //*)
   
   LTC5904Frame_SERIAL();

#if YesWindows 
  #if DEBUG
	AllocConsole();
	freopen("CON", "w", stdout); // redirects stdout
	freopen("CON", "w", stderr); // redirects stderr
  #endif
#endif
   
}



LTC5904Frame::~LTC5904Frame()
{
    if(portok==1)	{ portok=0;	 CloseRs232();	}   
    Close();
    
}



void LTC5904Frame::OnBexitClick(wxCommandEvent& event)
{
	if(portok==1)	{ portok=0;	 CloseRs232();	}   
    Close();
    
}


void LTC5904Frame::OnBfrecuClick(wxCommandEvent& event)
{
 long frecuencia;
 wxString msg;
	msg = Bgo->GetValue();
	frecuencia=wxAtoi(msg);
	if(frecuencia<1040 || frecuencia>68020000)
		{
			Bconsola->SetValue(_("ERROR 1040<frecuencia<68020000"));
			return;
		}
	
	sprintf(CADE1,"FREQ %li",frecuencia);
	msg= wxString::FromUTF8(CADE1);
	Bconsola->SetValue(msg);
	SendData();
}

void LTC5904Frame::OnClose(wxCloseEvent& event)
{
	if(portok==1)	{ portok=0;	 CloseRs232();	}  
    Close();
}



void LTC5904Frame::OnTimer1Trigger(wxTimerEvent& event)
{		
	 int nbytes;
	 //wxString msg;
 
	tiempo0--; tiempo2--;
	if(tiempo0<0)
		{
		 tiempo0=300;
#if DEBUG 		 
		 printf("3Segundo\n");
#endif	
		}


//__________________________________________________
// cada 0,5 segundos
    if(portok==1 && tiempo2<0)
		{
         tiempo2=2;
#if YesWindows
						while(( nbytes = ReadSerie(hSerial, Binput2, 1)>0 ))
#else
						while(( nbytes = read(fdrs232, Binput2, 1)>0 ))
#endif
							{					
										Binput[ContadorI]=Binput2[0];
										if(ContadorI<MAXINPUT-2)   ContadorI++;
		//								printf("Contador=%d %d  CHAR=%c\n",ContadorI,Binput2[0],Binput2[0]);
										if (Binput2[0] == '\n')
										   {
											if(ContadorI<2)ContadorI=2;
											Binput[ContadorI-1]=0;
											ContadorI=0;
											sprintf(VARI,"%s",Binput);
											printf("==%s\n",VARI);			
											analizar();									
										   }
							}
		}		

}










void LTC5904Frame::analizar(void)
{
 wxString msg;
 int z;
    
    for(z=0;z<20;z++)  if(13==VARI[z]) { VARI[z]=0;  break; }
    if(0==strncmp(VARI,CLAVE,4))
		{
			printf("OK_%s\n",CLAVE);
			Bconsola->SetValue(_("LTC5904 ENCONTRADO"));
			goto salirAna;
		}	
    	
 salirAna:
 ;		
}



void LTC5904Frame::SendData(void)
{
  sprintf(CADE2,"%s\n",CADE1);
#if DEBUG 
    printf("%s",CADE2);
#endif
    if(portok==1) PrintSerial(CADE2);
}




//__________________________________
int LTC5904Frame::SearchPort2(void)
{
	int z,zz,nbytes;
	int  ContadorI=0;
	char Binput[MAXINPUT];
	char Binput2[10];
	
 #if YesWindows
		for (z=0;z<11;z++)
 #else
			for (z=0;z<7;z++)
 #endif
			{
				MODEMDEVICE=myport[z];
				printf("Test Port %s\n",MODEMDEVICE);			
				if(0==IniRs232())
				   {
					printf("OK %s\n",MODEMDEVICE);	
					DelayMs(700);
					ContadorI=0;
					for(zz=0;zz<20;zz++)
					   {
						DelayMs(100);
#if YesWindows
						while(( nbytes = ReadSerie(hSerial, Binput2, 1)>0 ))
#else
						while(( nbytes = read(fdrs232, Binput2, 1)>0 ))
#endif
							{
								Binput[ContadorI]=Binput2[0];
								if(ContadorI<MAXINPUT-2)   ContadorI++;
								if (Binput2[0] == '\n')
								   {
									if(ContadorI<2)ContadorI=2;
									Binput[ContadorI-1]=0;
									ContadorI=0;
									if(!strncmp(Binput,CLAVE,5))
									   {
										printf("%s found at %s\n",CLAVE,MODEMDEVICE);
										CloseRs232();
										return z ;
									   }									
								    }
							}
						}

					}
			 }
	printf("%s no found \n",CLAVE);
	return -1;
}



int LTC5904Frame::LTC5904Frame_SERIAL(void)
{
  int z;
  wxString msg;
		if(inicio==1)
		{
			inicio=0;
			z=SearchPort2();
		if(z==-1)
			 {
				 portok=0;
				 printf("No %s\n",CLAVE);
				 msg.Printf(wxT("No encontrado LTC5904"));
				 wxMessageBox(msg, wxT("ERROR"), wxOK | wxICON_INFORMATION, this);
				 msg.Printf(wxT("No port"));
				 TextCtrl1->SetValue(msg);
				 return -1;
			 }
			else
		     {

			MODEMDEVICE=myport[z];
			#if YesWindows
				if(hSerial)CloseRs232();
			#else
				if(fdrs232)CloseRs232();
			#endif
									
			#if DEBUG     
				printf("Init\n");
			#endif
			#if YesWindows
				if(hSerial)CloseRs232();
			#else 
				if(fdrs232)CloseRs232();    
			#endif
			
			if(0==IniRs232())
						{
							msg= wxString::FromUTF8(MODEMDEVICE);
							TextCtrl1->SetValue(msg+_(" ")+_("9600,0,8,1"));      
							printf("SI %s\n",MODEMDEVICE);									    
							portok=1;
						}																		
			 }		 
		}							
 return 0;
}
